???File Path
==========
***...\Models\corporate\CorporateModels.cs


// @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
// @@@@@@@@@@@@@  CorporateBookingRule  @@@@@@@@@@@@@
// @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
public class MdlCorporateBookingRule : MdlUserAction {

	public long binCorporateBookingRuleId { get; set; } = 0;
	[Required(AllowEmptyStrings = false)]
	[DisplayFormat(ConvertEmptyStringToNull = false)]
	[StringLength(150)]
	[Display(Name = "Rule Name")]
	public string strRuleName { get; set; } = "";
	
	public long? binCustomerId { get; set; } = null;
	public short sinAllowedAllCustomers { get; set; } = 1;
	
	public string strRemarks { get; set; } = "";
	public short sinRecordStatus { get; set; } = 1;
	
	public double dblAirSlabFrom { get; set; } = 0.0;
	public double dblAirSlabTo { get; set; } = 0.0;
	public short sinOnewayTrip { get; set; } = 1;
	public short sinRoundTrip { get; set; } = 1;
	public short sinMultiTrip { get; set; } = 1;
	public short sinIfExcludeCabinClass { get; set; } = 0;
	public long[] arlFkCabinClass { get; set; } = Array.Empty<long>();
	public string strDbArlFkCabinClass { get; set; } = "";
	public string[] artBookingClassChrs { get; set; } = Array.Empty<string>();
	public string strDbArtBookingClassChrs { get; set; } = "";
	public short sinIfExcludeBookingClassChrs { get; set; } = 0;
	public short sinIfExcludeSourceAirport { get; set; } = 0;
	public long[] arlFkSourceAirportIds { get; set; } = Array.Empty<long>();
	public string strDbArlFkSourceAirportIds { get; set; } = "";
	public short sinIfExcludeDestinationAirport { get; set; } = 0;
	public long[] arlFkDestinationAirportIds { get; set; } = Array.Empty<long>();
	public string strDbArlFkDestinationAirportIds { get; set; } = "";
	public short sinCodeSharingType { get; set; } = 0;
	public long[] arlFkCodeSharingAirlineMasterIds { get; set; } = Array.Empty<long>();
	public string strDbArlFkCodeSharingAirlineMasterIds { get; set; } = "";
	public long[] arlFkCodeSharingAirlineCategoryIds { get; set; } = Array.Empty<long>();
	public string strDbArlFkCodeSharingAirlineCategoryIds { get; set; } = "";
	public long[] arlFkCodeSharingAirlineGroupIds { get; set; } = Array.Empty<long>();
	public string strDbArlFkCodeSharingAirlineGroupIds { get; set; } = "";
	public long[] arlFkCodeSharingAirlineTypeIds { get; set; } = Array.Empty<long>();
	public string strDbArlFkCodeSharingAirlineTypeIds { get; set; } = "";
	public long[] arlFkCodeSharingAirlineFamilyIds { get; set; } = Array.Empty<long>();
	public string strDbArlFkCodeSharingAirlineFamilyIds { get; set; } = "";
	public short sinNoOfStops { get; set; } = 0;
	public long[] arlFkTicketTypeIds { get; set; } = Array.Empty<long>();
	public string strDbArlFkTicketTypeIds { get; set; } = "";
	
	public short sinIfExcludeAirline { get; set; } = 0;
	public long[] arlFkAirlineMasterIds { get; set; } = Array.Empty<long>();
	public string strDbArlFkAirlineMasterIds { get; set; } = "";
	public long[] arlFkAirlineCategoryIds { get; set; } = Array.Empty<long>();
	public string strDbArlFkAirlineCategoryIds { get; set; } = "";
	public long[] arlFkAirlineGroupIds { get; set; } = Array.Empty<long>();
	public string strDbArlFkAirlineGroupIds { get; set; } = "";
	public long[] arlFkAirlineTypeIds { get; set; } = Array.Empty<long>();
	public string strDbArlFkAirlineTypeIds { get; set; } = "";
	public long[] arlFkAirlineFamilyIds { get; set; } = Array.Empty<long>();
	public string strDbArlFkAirlineFamilyIds { get; set; } = "";
	
	public double dblHotelSlabFrom { get; set; } = 0.0;
	public double dblHotelSlabTo { get; set; } = 0.0;
	public short sinStarRate { get; set; } = 0;
	public short sinIfExcludeHotel { get; set; } = 0;
	public long[] arlFkHotelMasterIds { get; set; } = Array.Empty<long>();
	public string strDbArlFkHotelMasterIds { get; set; } = "";
	public long[] arlFkHotelCategoryIds { get; set; } = Array.Empty<long>();
	public string strDbArlFkHotelCategoryIds { get; set; } = "";
	public long[] arlFkHotelGroupIds { get; set; } = Array.Empty<long>();
	public string strDbArlFkHotelGroupIds { get; set; } = "";
	public long[] arlFkHotelTypeIds { get; set; } = Array.Empty<long>();
	public string strDbArlFkHotelTypeIds { get; set; } = "";
	public long[] arlFkHotelFamilyIds { get; set; } = Array.Empty<long>();
	public string strDbArlFkHotelFamilyIds { get; set; } = "";
	public long[] arlFkRoomTypeIds { get; set; } = Array.Empty<long>();
	public string strDbArlFkRoomTypeIds { get; set; } = "";
	public long[] arlFkMealsPlanIds { get; set; } = Array.Empty<long>();
	public string strDbArlFkMealsPlanIds { get; set; } = "";
	
}

public class MdlReqCorporateBookingRule : MdlRequest {

	public MdlCorporateBookingRule mdlCorporateBookingRule { get; set; } = new MdlCorporateBookingRule();
}

public class MdlResCorporateBookingRule : MdlResponse {

	public MdlCorporateBookingRule mdlCorporateBookingRule { get; set; } = new MdlCorporateBookingRule();
}

public class MdlResCorporateBookingRuleList : MdlResponse {

	public List<MdlCorporateBookingRule> lstMdlCorporateBookingRule { get; set; } = new List<MdlCorporateBookingRule>();
}

public class MdlResCorporateBookingRuleInit : MdlResponse {
	public List<MdlBaseIntId> lstMdlCustomerBaseIntId { get; set; } = new List<MdlBaseIntId>();


	public List<MdlCorporateBookingRule> lstMdlCorporateBookingRule { get; set; } = new List<MdlCorporateBookingRule>();
}

